chiark / gitweb /
el/dot-emacs.el: Load ERC configuration in advance.
[profile] / setup
... / ...
CommitLineData
1#! /bin/bash
2
3set -e
4
5###--------------------------------------------------------------------------
6### Basic setup.
7
8umask 002
9
10sub=
11mkdir -p $HOME$sub
12
13: ${REPO=http://ftp.distorted.org.uk/ftp/pub/mdw/profile}
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17###--------------------------------------------------------------------------
18### Sort out command line.
19
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
36here=$(pwd)
37
38## Suss out how to print things
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
48## Find out how to fetch things over the net
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
80echo "Installing packages..."
81systems="
82 mlib:crc-mktab
83 checkpath:tmpdir
84"
85[ "$xstuff" ] && systems="$systems
86 xtoys:xatom
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
90 sys=$1 prog=$2
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100 $echon " unpacking$echoc"
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
103 $echon " configuring$echoc"
104 cd $dir
105 mkdir build
106 cd build
107 ../configure --prefix=$HOME$sub >>buildlog 2>&1
108 $echon " building$echoc"
109 make >>buildlog 2>&1
110 $echon " installing$echoc"
111 make install >>buildlog 2>&1
112 echo " done."
113 )
114 fi
115done
116echo " all done."
117
118###--------------------------------------------------------------------------
119### Install global configuration.
120
121echo -n "Installing dotfile configuration:"
122if [ -f $HOME$sub/.mdw.conf ]; then
123 echo " already installed."
124else
125 cp mdw.conf $HOME$sub/.mdw.conf
126 echo " done."
127fi
128
129## Symlink the various dotfiles into place
130dotfiles="
131 bash_profile bash_logout bashrc inputrc bash_completion
132 emacs emacs-calc vm gnus.el ercrc.el
133 vimrc mg zile
134 mailrc signature
135 cgrc tigrc
136 gdbinit
137 guile
138 toprc
139 aspell.conf
140 lisp-init.lisp:.cmucl-init.lisp
141 lisp-init.lisp:.sbclrc
142 lisp-init.lisp:.clisprc.lisp
143 lisp-init.lisp:.eclrc
144 swank.lisp
145 dircolors colordiffrc screenrc cvsrc indent.pro"
146[ "$xstuff" ] && dotfiles="$dotfiles
147 xinitrc xsession Xdefaults vncrc vncsession
148 fonts.conf
149 stalonetrayrc
150 putty-defaults:.putty/sessions/Default%20Settings
151 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
152 e-keybindings.cfg:.enlightenment/keybindings.cfg
153 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
154 e16-bindings:.e16/bindings.cfg"
155echo "Installing dotfiles..."
156for d in $dotfiles; do
157 target=.$d
158 case $d in
159 *:*) target=${d#*:} d=${d%%:*};;
160 esac
161 ft=$HOME$sub/$target
162 dir=${ft%/*}
163 mkdir -p $dir
164 ln -s $here/dot/$d $ft.new
165 mv $ft.new $ft
166 echo " $target"
167done
168echo " all done."
169
170## Substitute things which need substituting.
171dotfilessubst="
172 gitconfig
173 pulse-default.pa.in:.pulse/default.pa"
174echo "Installing dotfiles with substitutions..."
175for d in $dotfilessubst; do
176 case $d in
177 *:*) target=${d#*:} d=${d%%:*};;
178 *) target=.$d d=$d.in;;
179 esac
180 ft=$HOME$sub/$target
181 dir=${ft%/*}
182 mkdir -p $dir
183 sed "
1841i\
185### generated by $here/setup; do not edit!\
186
187/@home@/ s\a\a$HOME\ag
188/@releasekey@/ s\a\a$(bin/mdw-conf release-key 481334C2)\ag
189/@gitignore@/ s\a\a$(bin/mdw-conf gitignore $here/git/gitignore)\ag
190" dot/$d >$ft.new
191 mv $ft.new $ft
192 echo " $target"
193done
194echo " all done."
195
196## Symlink backgrounds.
197backgrounds="
198 jue-peek.jpg
199 medusa.jpg
200 bsg-supper.jpg
201 rayne.jpg
202 hypatia.jpg
203 noodly.jpg
204 lovelace.jpg"
205if [ "$xstuff" ]; then
206 echo "Installing backgrounds..."
207 for b in $backgrounds; do
208 for e in enlightenment e16; do
209 dir=$HOME$sub/.$e/backgrounds
210 t=$dir/$b
211 mkdir -p $dir
212 ln -s $here/bg/$b $t.new
213 mv $t.new $t
214 done
215 echo " $b"
216 done
217 echo " all done."
218fi
219
220###--------------------------------------------------------------------------
221### Install useful scripts included in this package.
222
223scripts="
224 mdw-editor
225 mdw-pager
226 mdw-conf
227 mdw-build
228 emacsclient-hack
229 movemail-hack
230 aspell-hack
231 emerge-hack
232 lesspipe.sh
233 start-ssh-agent
234 svnwrap
235 hyperspec"
236[ "$xstuff" ] && scripts="$scripts
237 xinitcmd
238 un-backslashify-selection
239 lock-screen
240 xshutdown"
241echo "Installing scripts..."
242mkdir -p $HOME$sub/bin
243for s in $scripts; do
244 ft=$HOME$sub/bin/$s
245 ln -s $here/bin/$s $ft.new
246 mv $ft.new $ft
247 echo " $s"
248done
249echo " all done."
250
251hacks="
252 ssh:ssh"
253echo "Installing hacks..."
254for h in $hacks; do
255 d=${h%%:*} h=${h#*:}
256 ft=$HOME$sub/bin/hacks/$d
257 mkdir -p $ft
258 ln -s $here/hacks/$h $ft/$h.new
259 mv $ft/$h.new $ft/$h
260 echo " $d:$h"
261done
262echo " all done."
263
264###--------------------------------------------------------------------------
265### Set up the Emacs config.
266
267$echon "Finding a suitable emacs:$echoc"
268emacs=no
269for i in emacs22 emacs23 emacs21 emacs; do
270 if type -p >/dev/null $i; then
271 emacs=$i
272 break
273 fi
274done
275if [ $emacs = no ]; then
276 echo " failed."
277 emacs=:
278else
279 echo " $emacs."
280fi
281
282echo "Installing Emacs packages..."
283emacspkg="
284 make-regexp
285 ew-hols
286 mdw-gnus-patch
287 git git-blame vc-git stgit
288 quilt"
289for elib in $emacspkg; do
290 $echon " $elib:$echoc"
291 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
292 (progn
293 (setq load-path (nconc load-path (list "~/lib/emacs")))
294 (kill-emacs (condition-case nil
295 (progn (load-library "'"$elib"'") 0)
296 (error 1))))'; then
297 echo " already installed."
298 else
299 if [ -f el/$elib.el ]; then
300 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
301 else
302 $echon " downloading$echoc"
303 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
304 fi
305 $echon " compiling$echoc"
306 (cd $HOME$sub/lib/emacs;
307 $emacs >/dev/null 2>&1 --no-site-file --batch \
308 --eval '(byte-compile-file "'"$elib.el"'")')
309 echo " done."
310 fi
311done
312echo " all done."
313
314$echon "Setting up Emacs configuration:$echoc"
315$echon " linking$echoc"
316for f in dot-emacs.el Makefile; do
317 set -- $(echo $link | tr : ' ')
318 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
319 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
320done
321$echon " compiling$echoc"
322make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
323echo " done."
324
325###----- That's all, folks --------------------------------------------------